From bde8b7cdf94336e4f2fb2510e21bd7ffc15d05ab Mon Sep 17 00:00:00 2001
From: Donghee Na <donghee.na@python.org>
Date: Sun, 1 Jun 2025 16:54:49 +0900
Subject: [PATCH] gh-134875: Fix mimallc build error for the old compilers

---
 Include/internal/mimalloc/mimalloc/internal.h | 4 ++--
 1 file changed, 2 insertions(+), 2 deletions(-)

diff --git a/Include/internal/mimalloc/mimalloc/internal.h b/Include/internal/mimalloc/mimalloc/internal.h
index 71b7ea702d6c5e..a7daa3a40a4c0b 100644
--- Include/internal/mimalloc/mimalloc/internal.h
+++ Include/internal/mimalloc/mimalloc/internal.h
@@ -634,10 +634,10 @@ static inline mi_block_t* mi_block_nextx( const void* null, const mi_block_t* bl
   mi_track_mem_defined(block,sizeof(mi_block_t));
   mi_block_t* next;
   #ifdef MI_ENCODE_FREELIST
-  next = (mi_block_t*)mi_ptr_decode(null, mi_atomic_load_relaxed(&block->next), keys);
+  next = (mi_block_t*)mi_ptr_decode(null, mi_atomic_load_relaxed((_Atomic(mi_encoded_t)*)&block->next), keys);
   #else
   MI_UNUSED(keys); MI_UNUSED(null);
-  next = (mi_block_t*)mi_atomic_load_relaxed(&block->next);
+  next = (mi_block_t*)mi_atomic_load_relaxed((_Atomic(mi_encoded_t)*)&block->next);
   #endif
   mi_track_mem_noaccess(block,sizeof(mi_block_t));
   return next;
